/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/



void Stylus::butLoadXML_clicked()
{
    open IN,"<data.xml";  
    undef $/;
    my $content=<IN>;
    close IN;
    
    my $doc=Qt::DomDocument();
    $doc->setContent($content);
    
    sub myinsert($$)
    {
#print $_[0]->nodeName()."\n";
	my $item;
	my $item = Qt::ListViewItem($_[1]);
	$item->setText(0, trUtf8($_[0]->nodeName() ) );
	$item->setDragEnabled(1);
	my $node=$_[0]->firstChild();
	while(! $node->isNull())
	{
	    if($node->isElement())
	    { 
		myinsert($node,$item);
	    }
	    $node=$node->nextSibling();
	}
    }
    
    listView1->clear();
    
    myinsert($doc->documentElement(),listView1);
    listView1->firstChild()->setOpen(1);
    setAcceptDrops(1);
    
}


void Stylus::butLoadOut_clicked()
{
    open IN,"<out.xml";  
    undef $/;
    my $content=<IN>;
    close IN;
    
    my $doc=Qt::DomDocument();
    $doc->setContent($content);
    
    listView2->clear();
    
    myinsert($doc->documentElement(),listView2);
    listView2->firstChild()->setOpen(1);
    
    setAcceptDrops(1);
    
}

void Stylus::setTemplate()
{
   print "Clicked\n";   
}

void Stylus::listView1_contextMenuRequested( QListViewItem *, const QPoint &, int )
{
    my $popup=Qt::PopupMenu(this,"MeinPopup");
    $popup->insertItem("Template",this,"test");
# connect(Stylus,"setTemplate",this,"setTemplate");
    $popup->popup($_[1],0);
#print "Drag\n"; 
#listView1->startDrag();
#my $d= Qt::DragObject( "text", this);
#$d->dragCopy();
}


void Stylus::init()
{
    butLoadXML_clicked();  
    butLoadOut_clicked();  
}


void Stylus::listView1_doubleClicked( QListViewItem * )
{
  print "Drag\n";

  my $drob;
# listView1->startDrag();
  $drob = Qt::TextDrag( "text", this );
  $drob->drag();
  print "Drag done\n";
}


void Stylus::listView1_dragEnterEvent(QDragEnterEvent * event)
{
   print "dragEnterEvent($_[0])\n";
   $_[0]->accept();
}


void Stylus::listView1_dropEvent(QDropEvent * event)
{
  print "dropEvent($_[0])\n";
  print $_[0]->data()."\n";
}

void Stylus::listView2_dropped( QDropEvent * )
{
    print "Dropped\n";
}


void Stylus::listView1_dropped( QDropEvent * )
{
  print "Dropped\n";
}
