#!/usr/bin/perl -w

use IO::Socket;

$socket=IO::Socket::INET->new(PeerAddr=>"localhost",PeerPort=>1072,Proto=>"tcp",Type=>SOCK_STREAM) or die "Konnte Verbindung zu localhost:1072 nicht herstellen: $@\n";

print $socket "R40000.0\n"; # Schwellwert
print $socket "P1\n";       # Relais aktivieren

#print scalar(<$socket>) foreach(1..15);

my $group=0; # Gruppenfunktion

if($group)
{
 eval("use Term::ReadKey;");
}

my $command;

open LOG,">>logfile.txt";
LOG->autoflush;


ReadMode('cbreak') if($group);
while(1)
{
  $command=ReadKey(0) if($group);
  print "Identfiziere $command*\n";
  print $socket "I$command*\n";
  print scalar(<$socket>);
  my $answer=scalar(<$socket>);
  print LOG localtime()." ".$answer;

}

close($socket);
ReadMode('normal') if($group);
close LOG;
